

        /****************************************************************
        *                                                               *
        *                          FINDER 3.0                           *
        *                                                               *
        *           (C) 1993 Australian National University             *
        *                                                               *
        *                      All rights reserved                      *
        *                                                               *
        * The information in this software is subject to change without *
        * notice and should not be construed as a commitment by the     *
        * Australian National University. The Australian National Uni-  *
        * versity makes no representations about the suitability of     *
        * this software for any purpose. It is supplied "as is" without *
        * express or implied warranty.  If the software is modified in  *
        * a manner creating derivative copyright rights, appropriate    *
        * legends may be placed on the derivative work in addition to   *
        * that set forth above.                                         *
        *                                                               *
        * Permission to use, copy, modify and distribute this software  *
        * and its documentation for any purpose and without fee is      *
        * hereby granted, provided that both the above copyright notice *
        * and this permission notice appear in all copies and sup-      *
        * porting documentation, and that the name of the Australian    *
        * National University not be used in advertising or publicity   *
        * pertaining to distribution of the software without specific,  *
        * written prior permission.                                     *
        *                                                               *
        ****************************************************************/

#include "FINDER.h"

main(argc,argv)
int argc;
char *argv[];
{
    int option;
    char filename[64];
    FILE *infil;
    void timesup();
    void intrupt();
    boolean pipe_out = false;

    piping = false;
    pipe_open = false;
    negative = false;
    pipe_out = false;
    *command_line = '\0';
    *filename = 0;
    while ((option = getopt (argc, argv, "c:f:n:p")) != -1)
	switch( option ) {
	  case 'c': strcat(command_line,optarg);
	    strcat(command_line," ");
	    break;
	  case 'f': strcpy(filename,optarg);
	    piping = true;
	    pipe_open = true;
	    break;
	  case 'n': strcpy(filename,optarg);
	    piping = true;
	    pipe_open = true;
	    negative = true;
	    break;
	  case 'p': pipe_out = true;
	    break;
        }

    signal( SIGALRM, timesup );
    signal( SIGINT, intrupt );

    initialize();
    read_job( stdin );
    pipe_open = false;
    if ( piping ) {
	if ( !(infil = fopen(filename,"r")) )
	    inerror("Cannot open file",filename);
	read_job( infil );
    }
    if ( *command_line ) {
	cmd_line_input = true;
	input_point = 0;
	strcat( command_line, " end." );
	read_job(0);
    }
    if ( pipe_out ) {
	strcpy( command_line, "setting ugly end." );
	cmd_line_input = true;
	input_point = 0;
	read_job(0);
    }
    tr_parameters.done = 0;
    alarm( setting.maxtime);
    if ( setting.pm.verbosity & pjob ) print_job();
    begin_time = timestamp();
    if ( piping ) while ( !tr_parameters.done && got_partial() ) {
	clauses_fail = true;
	go(0);
	if ( negative && clauses_fail ) {
	    updates[current_theory]++;
	    print_model();
	    if ( updates[current_theory] && 
		updates[current_theory] == setting.max_models )
		job_done( &tr_parameters, "limit on number of solutions" );
	}
    }
    else go(0);
    end_time = timestamp();
    if ( setting.pm.verbosity & pstats ) printstats();
    else if ( !setting.pm.pretty ) printf("end\n");
    alarm(0);
}




/*
*	Action on signal from alarm.
*/

void timesup()
{
    job_done( &tr_parameters, "time limit" );
}


/*
*	Action on signal from ^C or whatever SIGINT may be.
*/

void intrupt()
{
    job_done( &tr_parameters, "interrupt" );
}
