// SCOTT prototypes seen by OTTER sources.

// process.c
boolean in_constraint_set(struct clause *cl);
void add_semantic_wt(struct clause *otter_cl);
void sem_res(struct clause *giv_cl);
void scott_control_memory();
void scott_delete_if_conjecture(struct clause *cl);
void scott_insert_conjecture(struct clause *cl);

// called from misc.c
void init_scott_options();
void init_distributions();
void automatic_3_settings();
void init_semantics(int argc, char *argv[]);
void init_clause_space();
void init_partitions();
void auto_set_conjecture();
void auto_set_sos(); 
void set_base();
void output_finder_stats(FILE *fp, int stats_level);
void set_up_model();

// and main.c
void output_weight_distn();

// called from clause.c
void in_set_to_str(char *in_set, struct clause *cl);
void scott_delete(struct list *lptr, struct clause *cl);
void scott_insert(struct list *lptr, struct clause *cl);
struct clause *semantic_selection(struct list *lptr);

// called from options.c
int change_scott_parm(FILE *fp, struct term *t, char *parm_name);
void auto_change_parm_str(FILE *fp, char *parm_name, float new_value);
