/*----------------------------------------------------------------------*\
                               "Sdef.h": 

       Constants global to SCOTT sources.
\*----------------------------------------------------------------------*/

/*---SCOTT_DEBUG()---------------------------------------------------*/
#ifdef DEBUG_SCOTT
#define SCOTT_DEBUG(event) \
{ \
    debug_partition(event); \
    debug_scan(event);\
}
#else
#define SCOTT_DEBUG(event);
#endif
/*--------------------------------------------------------------------*/


#define MAX_DIST 20

// strategy control points
#define SET             0
#define FAILS           1
#define TEST            2
#define RECORD_EVENT    3
#define RECORD_KEPT     4

/*---------------- Statistics for semantic guidance ------------------*/

#define MAX_TSTATS           40 // declared also in SFOshared_defs.h

#define ATTEMPTS              0
#define COVER_ATTEMPTS        1
#define REFINE_ATTEMPTS       2
#define REPLACEMENT_ATTEMPTS  3

#define KEPT                  4
#define COVER_KEPTS           5
#define REFINE_KEPTS          6

#define FOR_SUBS              7
#define REFINE_FAILS          8
#define SOS_COVERS            9

#define BACK_SUBS            10 
#define CULLED               11
#define CLASHES              12

#define SEM_BASE_SIZE        13
#define BASE_CL_ADDED        14
#define BASE_CL_SKIPPED      15
#define BASE_EXTENSION_FAILS 16

#define GIVENS_FROM_FIRST    17
#define CL_SEM_QUEUED        18
#define SUCCESSFUL_RETESTS   19
#define SEMANTIC_SELECTIONS  20

#define FAILS_IN_PERSIST     21
#define PFAIL_TIME_INC       23
#define PFAIL_TIME_DEC       24
#define PFAIL_PROB_DEC       25
#define PFAIL_COST_VS_TIME   26
#define PFAIL_TIME_ACCRUED   27
#define PFAIL_COST_VS_RETURN 28
#define PFAIL_COST_VS_PROB   29

#define MAXISETS_AT_END_DEV  30

/*------------- Parms for semantic guidance ------------------------*/

#define MAX_TPARMS           20 // declared also in SFOshared_defs.h

#define MAX_SEARCH_TIME       0
#define MIN_SEARCH_TIME       1
#define MAX_DOMAIN_SIZE       2
#define MIN_DOMAIN_SIZE      18

#define MAX_FAILS             3 // max consecutive failures to form a maxiset
#define MAX_NUM_MAXISETS      4
#define MIN_NUM_MAXISETS      5
#define MIN_MAXISET_ATTEMPTS  6

#define SEM_QUEUE_LIMIT       7
#define MIN_REFINEMENT        8
#define MAX_NULL_SET_SIZE     9
#define VERBOSITY            10
#define MAX_NEW_BASE_CL      11
#define TRUE_WEIGHT          12

#define LIMIT_WEIGHT_AT      13
#define CULL_WEIGHTS_OVER    14
#define LIMIT_VARS_AT        15
#define CULL_VARS_OVER       16

#define CONTROL_MEMORY_LIMIT 17

/*-- Indices for fParms[] (parameters that take float values)---------*/
#define MAX_FPARMS          10 // declared also in SFOshared_defs.h

#define GUIDANCE_FACTOR      0
#define COST_MARGIN          1
#define MIN_PROB_EXTN        2
#define SMOOTHING_RATIO      3
#define TOLERANCE            4
#define SCALE_WEIGHT         5  
#define MIN_COST_OF_ATTEMPT  8

/*-------------------------------------------------------------*/


/*--History event definitions---------------------------------------*/

#define STRENGTHEN_EQ_DEF	"\n\nstrengthen_eq_def\n"
#define VERIFY_MODEL		"\n\nverify model\n"

#define SELECT_LIGHTEST		"->l..."
#define SELECT_BEST_SEM		"->s..."
#define START_INPUT_FIRST	"->f..."
#define START_SEM_BREADTH	"->b..."
#define SELECT_QUEUE            "Q"

#define DISCARD_BAD_MAXISET	"B..."
#define COVER_NEW_CLAUSES	"C"
#define REFINE_CHOICE	        "R"

#define DISCARD_NEW_BASE_CL	"[dbase]"
#define STRENGTHEN_BASE_FAILURE "[fbase]"

#define FOR_SUB_MAXISET		"[fsub]"
#define BACK_SUB_MAXISET	"[bsub]"
#define MAXISET_CULLED		"[cull]"
#define FAILS_TO_REFINE	        "[ref]"
#define COVERS_SOS              "[sos]"

