/*-----------------------------------------------------------------------*
 *                                                                       *
 *              External variables shared by SCOTT sources               *
 * ----------------------------------------------------------------------*/

#ifdef IN_SCOTT
#define SGLOBAL
#else
#define SGLOBAL extern				
#endif

SGLOBAL struct {  /* fParms are real valued options */
  char *name;
  double val;
  double min, max;  /* minimum and maximum permissible values */
} fParms[MAX_FPARMS];

SGLOBAL struct {  /* tParms are integer valued options */
  char *name;
  int val;
  int min, max;  /* minimum and maximum permissible values */
} tParms[MAX_TPARMS];

SGLOBAL int tStats[MAX_TSTATS];

struct partition {
  int sos[MAXISET_ARRAY][MAXISET_ARRAY];
  int usable[MAXISET_ARRAY][MAXISET_ARRAY];
};

struct clause_dptr {  /*a doubly linked list of clause pointers */
  struct clause *c;
  struct clause_dptr *prev, *next;
};

struct external_list {
  struct clause_dptr *first_cp, *last_cp;
};

struct data_array {
  char name[20];
  int num_points;
  float total;
  float list[NUM_POINTS] ;
};

struct Distn {
  int freq[MAX_DIST];
  int freq_over_set[MAXISET_ARRAY][MAX_DIST];
  int min,max;
  int max_outlier, min_outlier;
  int num_outliers_up, num_outliers_down;
  float average, median, variance;
  int interval;
  char *name;
  int (*property)();
  int *limit;
  int *cull_over;
  int *limit_at;
};

SGLOBAL struct external_list conjecture;
SGLOBAL struct external_list semantic_base;
SGLOBAL struct external_list sos_scan[MAXISET_ARRAY];
SGLOBAL struct external_list failed_clauses[MAXISET_ARRAY];
SGLOBAL struct external_list new_base_clauses;

// these are shared and referenced often enough
SGLOBAL int last_queue_theory;
SGLOBAL int last_set_index;         // largest availiable maxiset index
SGLOBAL int num_maxisets;         // number of maxisets in the current rose
SGLOBAL int constraint_set;       // maxiset used for semantic resolution
SGLOBAL boolean active[MAXISET_ARRAY]; // satus of maxisets index's
                                       // note the zero theory is always active
SGLOBAL int null_set_size;
SGLOBAL boolean develop_semantics;
SGLOBAL boolean recording;
